/********************************************************************************************
 *
  * Copyright 2012-2018  Frank Gollnik  <http://www.jabotics.org>
*
 * 
 * This file is part of the Java software package org.jabotics (in the following: Jabotics).
 * 
 * Jabotics is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Jabotics is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jabotics.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * Diese Datei ist Teil des Java-Software-Pakets org.jabotics (im Folgenden kurz: Jabotics).
 * 
 * Jabotics ist Freie Software: Sie können es unter den Bedingungen
 * der GNU General Public License, wie von der Free Software Foundation,
 * Version 3 der Lizenz oder (nach Ihrer Wahl) jeder späteren
 * veröffentlichten Version, weiterverbreiten und/oder modifizieren.
 * 
 * Jabotics wird in der Hoffnung, dass es nützlich sein wird, aber
 * OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 * Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
 * Siehe die GNU General Public License für weitere Details.
 * 
 * Sie sollten eine Kopie der GNU General Public License zusammen mit Jabotics
 * erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************************/


package org.jabotics.robot.defs;


/**
 * This class defines constants used throughout the package org.jabotics.robot.
 * 
 * @author  Frank Gollnik
 * @version 1.1.1
 */
public class D
{
    public static final int SENSOR_PORT_NUMBER = ESensorPort.values().length;
    public static final int BUTTON_NUMBER = EButtonType.values().length;
    public static final int TOTAL_SENSOR_NUMBER = SENSOR_PORT_NUMBER + BUTTON_NUMBER;
    public static final int MOTOR_PORT_NUMBER = EMotorPort.values().length;

    public static final double TWO_PI = 2.0 * Math.PI;
    public static final double RAD_TO_DEGREE = 180.0 / Math.PI;
    public static final double DEGREE_TO_RAD = Math.PI / 180.0;
    public static final float PI_F = (float) Math.PI;
    public static final float TWO_PI_F = (float) TWO_PI;
    public static final float RAD_TO_DEGREE_F = (float) RAD_TO_DEGREE;
    public static final float DEGREE_TO_RAD_F = (float) DEGREE_TO_RAD;

    public static final double SQRT2 = Math.sqrt(2.0);
    public static final double SQRT05 = 0.5 * SQRT2;
    public static final double ONE_PLUS_SQRT2 = 1.0 + SQRT2;
    public static final double ONE_PLUS_SQRT05 = 1.0 + SQRT05;
    public static final double ONEHALF_MINUS_ONEHALF_SQRT05 = 0.5 * (1.0 - SQRT05);
    public static final float SQRT2_F = (float) SQRT2;
    public static final float SQRT05_F = (float) SQRT05;
    public static final float ONE_PLUS_SQRT2_F = (float) ONE_PLUS_SQRT2;
    public static final float ONE_PLUS_SQRT05_F = (float) ONE_PLUS_SQRT05;
    public static final float ONEHALF_MINUS_ONEHALF_SQRT05_F = (float) ONEHALF_MINUS_ONEHALF_SQRT05;
}
