/********************************************************************************************
 *
 * Copyright 2012-2018  Frank Gollnik  <http://www.jabotics.org>
 *
 * 
 * This file is part of the Java software package org.jabotics (in the following: Jabotics).
 * 
 * Jabotics is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Jabotics is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Jabotics.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * 
 * Diese Datei ist Teil des Java-Software-Pakets org.jabotics (im Folgenden kurz: Jabotics).
 * 
 * Jabotics ist Freie Software: Sie können es unter den Bedingungen
 * der GNU General Public License, wie von der Free Software Foundation,
 * Version 3 der Lizenz oder (nach Ihrer Wahl) jeder späteren
 * veröffentlichten Version, weiterverbreiten und/oder modifizieren.
 * 
 * Jabotics wird in der Hoffnung, dass es nützlich sein wird, aber
 * OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 * Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
 * Siehe die GNU General Public License für weitere Details.
 * 
 * Sie sollten eine Kopie der GNU General Public License zusammen mit Jabotics
 * erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************************/


package org.jabotics.robot.sim;

import java.awt.Graphics2D;
import java.awt.Shape;


/**
 * Beschreiben Sie hier die Klasse XGraphicsShape.
 * 
 * @author  Frank Gollnik
 * @version 1.1.1
 */
public class XGraphicsShape extends BGraphicsElement
{
    // Instanzvariablen - ersetzen Sie das folgende Beispiel mit Ihren Variablen
    private Shape mShape = null;
    boolean mDraw = true;
    boolean mFill = false;

    /**
     * Konstruktor für Objekte der Klasse XGraphicsShape
     */
    public XGraphicsShape(Shape shape)
    {
        // Instanzvariable initialisieren
        mShape = shape;
    }

    public synchronized void setDraw(boolean draw)
    {
        mDraw = draw;
    }

    public synchronized void setFill(boolean fill)
    {
        mFill = fill;
    }

    public synchronized void setShape(Shape shape)
    {
        mShape = shape;
    }

    protected synchronized void paintInLocalContext(Graphics2D g)
    {
        if (null != mShape)
        {
            if (mFill) g.fill(mShape);
            if (mDraw) g.draw(mShape);
        }
    }
}
